﻿using Infragistics.Win.UltraWinEditors;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;

namespace UltraTextEditorAutoSize
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            this.InitializeComponent();
            this.uiElementViewerDialog1.Show();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraTextEditor1.Multiline = true;
            this.ultraTextEditor1.WordWrap = true;
        }

        private void ultraTextEditor1_ValueChanged(object sender, EventArgs e)
        {
            UltraTextEditor editor = sender as UltraTextEditor;
            if (editor != null)
            {
                AdaptHeight(editor);
            }
        }

        const int EM_GETLINECOUNT = 0xBA;
        
        [DllImport("user32.dll", CharSet = CharSet.Auto)]
        static extern IntPtr SendMessage(IntPtr hWnd, UInt32 Msg, IntPtr wParam, IntPtr lParam);

        public static void AdaptHeight(Control editor)
        {
            editor.Update();
            var rows = (int)SendMessage(editor.Handle, EM_GETLINECOUNT, IntPtr.Zero, IntPtr.Zero);
            editor.Height = rows * editor.Font.Height + 1 + editor.Margin.Vertical;
        }

        private void ultraTextEditor1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Enter)
            {
                ultraTextEditor1.AutoSize = false;
                ultraTextEditor1.Height += this.ultraTextEditor1.Font.Height + this.ultraTextEditor1.Margin.Vertical;
            }
        }
    }
}
